from time import time
import unittest

try:
    from Products.CheckoutableTemplates import slimmer
except ImportError:
    try:
	import slimmer
    except ImportError:
	import sys
	sys.path.insert(0,'../')
	import slimmer
	




from codechunks import *

class SlimmerTestCase(unittest.TestCase):
    
    def _assert(self, str1, str2):
	""" special kind of assertEqual that strips """
	if not str1.strip() == str2.strip():
	    print "-"*70
	    print "DIFFERENCES"
	    print "1|"
	    print str1.strip()
	    print "2|"
	    print str2.strip()
	    print "-"*70
	print len(str1.strip()), len(str2.strip())
	assert str1.strip() == str2.strip()
	#return self.assertEqual(str1.strip(), str2.strip())
    
    def timer(self, name, timeittook, size1, size2):
	record = {'name':name, 'time':timeittook,
	          'size1':size1, 'size2':size2}
	records = self.timed_records
	records.append(record)
	self.time_records = records

    
    def setUp(self):
	self.timed_records=[]
	
    def tearDown(self):
	for record in self.timed_records:

	    print "-- %s --:"%record['name']
	    print "%s seconds"%round(record['time'], 6)
	    print "Was: %s\tNow: %s"%(record['size1'], record['size2'])
	    percent = round(100*record['size2']/float(record['size1']), 5)
	    percent = "%s%%"%percent
	    difference = record['size1'] - record['size2']
	    print "Difference: %s (%s)"%(difference, percent)
	    print 
	    

    def atest(self, str1, str2, name, func, *args, **kw):
	""" standard type of test """
	before = str1
	expect = str2
	
	t0=time()
	args = [before]+list(args)
	result = apply(func, args, kw)
	T = time()-t0
	
	self.timer(name,time()-t0, len(before), len(result))
	
	self._assert(result, expect)

	
	
    #--- Start the madness! ----------------------------------------------
    
    def testCSS1(self):
	before = CSS_1
	expect = expect_CSS_1
	self.atest(before, expect, "CSS1", slimmer.css_slimmer)
	
    def testCSS2(self):
	before = CSS_2
	expect = expect_CSS_2
	self.atest(before, expect, "CSS2", slimmer.css_slimmer)
	
    def testHTML1(self):
	before = open('HTML1.html','r').read()
	expect = open('HTML1.output.html','r').read()
	self.atest(before, expect, "HTML1", slimmer.html_slimmer)
	
    def testXHTML1(self):
	before = open('XHTML1.html','r').read()
	#f=open('XHTML1.output.html','w')
	#f.write(slimmer.xhtml_slimmer(before))
	#f.close()
	expect = open('XHTML1.output.html','r').read()
	self.atest(before, expect, "XHTML1", slimmer.xhtml_slimmer)
	
	
    

def suite():
    return unittest.makeSuite(SlimmerTestCase)
	
	
if __name__ == '__main__':
    unittest.main()
	